<?php

namespace HCM\FPA\ObrigacaoLegal\Manad\Blocos\Registros;

use HCM\FPA\ObrigacaoLegal\Manad\Blocos\Registros\Registro0000;

class RegistroK250 extends Registro0000 {

    private $_cnpjCei;
    private $_indFl;
    private $_codLtc;
    private $_regTrab;
    private $_dtComp;
    private $_dtPgto;
    private $_cob;
    private $_ocorr;
    private $_descCargo;
    private $_qtdDepIr;
    private $_qtdDepSf;
    private $_vlBaseIrrf;
    private $_vlBasePs;

    public function geraRegistroK250(){
        $this->_geraRegistro(self::REGISTRO_K250);
    }

    private function _geraRegistro($tpRegistro){
        // Ordem 1
        $this->atribuiDadoManad($tpRegistro);
        // Ordem 2
        $this->atribuiDadoManad($this->_cnpjCei);
        // Ordem 3
        $this->atribuiDadoManad($this->_indFl);
        // Ordem 4
        $this->atribuiDadoManad($this->_codLtc);
        // Ordem 5
        $this->atribuiDadoManad($this->_regTrab);
        // Ordem 6
        $this->atribuiDadoManad($this->_dtComp);
        // Ordem 7
        $this->atribuiDadoManad($this->_dtPgto);
        // Ordem 8
        $this->atribuiDadoManad($this->_cob);
        // Ordem 9
        $this->atribuiDadoManad($this->_ocorr);
        // Ordem 10
        $this->atribuiDadoManad($this->_descCargo);
        // Ordem 11
        $this->atribuiDadoManad($this->_qtdDepIr);
        // Ordem 12
        $this->atribuiDadoManad($this->_qtdDepSf);
        // Ordem 13
        $this->atribuiDadoManad($this->_vlBaseIrrf, false, parent::NUMERICO);
        // Ordem 14
        $this->atribuiDadoManad($this->_vlBasePs, true, parent::NUMERICO);
    }
    
    public function setCnpjCei($cnpjCei){
        $this->_cnpjCei = $cnpjCei;
    }
    public function setIndFl($indFl){
        $this->_indFl = $indFl;
    }
    public function setCodLtc($codLtc){
        $this->_codLtc = $codLtc;
    }
    public function setRegTrab($regTrab){
        $this->_regTrab = $regTrab;
    }
    public function setDtComp($dtComp){
        $this->_dtComp = $dtComp;
    }
    public function setDtPgto($dtPgto){
        $this->_dtPgto = $dtPgto;
    }
    public function setCob($cob){
        $this->_cob = $cob;
    }
    public function setOcorr($ocorr){
        $this->_ocorr = $ocorr;
    }
    public function setDescCargo($descCargo){
        $this->_descCargo = $descCargo;
    }
    public function setQtdDepIr($qtdDepIr){
        $this->_qtdDepIr = $qtdDepIr;
    }
    public function setQtdDepSf($qtdDepSf){
        $this->_qtdDepSf = $qtdDepSf;
    }
    public function setVlBaseIrrf($vlBaseIrrf){
        $this->_vlBaseIrrf = $vlBaseIrrf;
    }
    public function setVlBasePs($vlBasePs){
        $this->_vlBasePs = $vlBasePs;
    }
}