<?php

namespace HCM\FPA\ObrigacaoLegal\Manad\Blocos\Registros;

use HCM\FPA\ObrigacaoLegal\Manad\Blocos\Registros\Registro0000;

class RegistroK300 extends Registro0000 {

    private $_cnpjCei;
    private $_indFl;
    private $_codLtc;
    private $_regTrab;
    private $_dtComp;
    private $_cobRub;
    private $_vlrRubr;
    private $_indRubr;
    private $_indBaseIrrf;
    private $_indBasePs;

    public function geraRegistroK300(){
        $this->_geraRegistro(self::REGISTRO_K300);
    }

    private function _geraRegistro($tpRegistro){
        // Ordem 1
        $this->atribuiDadoManad($tpRegistro);
        // Ordem 2
        $this->atribuiDadoManad($this->_cnpjCei);
        // Ordem 3
        $this->atribuiDadoManad($this->_indFl);
        // Ordem 4
        $this->atribuiDadoManad($this->_codLtc);
        // Ordem 5
        $this->atribuiDadoManad($this->_regTrab);
        // Ordem 6
        $this->atribuiDadoManad($this->_dtComp);
        // Ordem 7
        $this->atribuiDadoManad($this->_cobRub);
        // Ordem 8
        $this->atribuiDadoManad($this->_vlrRubr, false, parent::NUMERICO);
        // Ordem 9
        $this->atribuiDadoManad($this->_indRubr);
        // Ordem 10
        $this->atribuiDadoManad($this->_indBaseIrrf, false, parent::NUMERICO);
        // Ordem 11
        $this->atribuiDadoManad($this->_indBasePs, true, parent::NUMERICO);
    }
    
    public function setCnpjCei($cnpjCei){
        $this->_cnpjCei = $cnpjCei;
    }
    public function setIndFl($indFl){
        $this->_indFl = $indFl;
    }
    public function setCodLtc($codLtc){
        $this->_codLtc = $codLtc;
    }
    public function setRegTrab($regTrab){
        $this->_regTrab = $regTrab;
    }
    public function setDtComp($dtComp){
        $this->_dtComp = $dtComp;
    }
    public function setCobRub($cobRub){
        $this->_cobRub = $cobRub;
    }
    public function setVlrRubr($vlrRubr){
        $this->_vlrRubr = $vlrRubr;
    }
    public function setIndRubr($indRubr){
        $this->_indRubr = $indRubr;
    }
    public function setIndBaseIrrf($indBaseIrrf){
        $this->_indBaseIrrf = $indBaseIrrf;
    }
    public function setIndBasePs($indBasePs){
        $this->_indBasePs = $indBasePs;
    }
}