<?php

namespace HCM\FPA\Services;


use Doctrine\ORM\EntityManager;
use HCM\FPA\Services\LoteLancEventoService;
use HCM\Util\HCMParameters;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Geral\Repository\RateioLancamentoRepository;

class RateioLancamentoService {
    
    protected $entityManager;
    
    public function __construct(EntityManager $entityManager, LoteLancEventoService $loteLancEventoService,  HCMParameters $hcmParameters, RateioLancamentoRepository $rateioLancamentoRepository) {
        $this->entityManager = $entityManager;
        $this->loteLancEventoService  = $loteLancEventoService;
        $this->hcmParameters = $hcmParameters;
        $this->rateioLancamentoRepository = $rateioLancamentoRepository;
    }

    public function importarCuponsOdhen($nrorg, $nrrateio, $nrestruturam, $cdunidade, $dtinicio, $dtfim)
    {
        try {
            $curl = curl_init();
            
            $urlBase = 'https://odh-sale-api.teknisa.cloud/pobrejuan/index.php';
            $token3469 = 'e+hE6UB4cOVyN5TWZr0pdox+u2/kNsmXEns/uooT2sY8DYAT+II9BfF0Him0PwSATiL6sHaoiCoHY++zpcFmLn4ixIe9z83IeL02a3c7gE/ecLKsrzLWkZTN1R8Zc4ShS0yN5wVyYFpBxHXu42nK1I2I9pPEZFwr59DmuzKSPg+CD2CRrDT9BqWlH7M+UhxsjhjFYq7R2fybUQ0h2jti2YmPOaFCZ82vKPs3jlwCnRYja/R3WevNy0z4wUTj9+xTFruZopONC52Ta5WcV7CMdQ==';
            $codUnidade = $cdunidade;//'0001';
            $dtInicial = $dtinicio;//'01/09/2023';
            $dtFinal = $dtfim;//'08/09/2023';
            
            curl_setopt_array($curl, array(
                CURLOPT_URL => $urlBase.'/getSales',
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => '',
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => 'POST',
                CURLOPT_POSTFIELDS => '{
                    "subsidiaryCode": "'.$codUnidade.'",
                    "dtInicial": "'.$dtInicial.'",
                    "dtFinal": "'.$dtFinal.'"
                }',
                CURLOPT_HTTPHEADER => array(
                    'Authorization: Bearer '.$token3469,
                    'Content-Type: application/json'
                ),
            ));
            
            $response = json_decode(curl_exec($curl), true);
            
            /*var_dump('{
                    "subsidiaryCode": "'.$codUnidade.'",
                    "dtInicial": "'.$dtInicial.'",
                    "dtFinal": "'.$dtFinal.'"
                }',$response,$message);die;*/
            
            curl_close($curl);
            
            $qtdLancamentos = 0;
            
            if (isset($response[0])) {
                $response = current($response);
                
                if (!isset($response['sales'])) {
                    throw new \Exception("Erro ao buscar as vendas {".json_encode($response)."}");
                }
            
                $sales = $response['sales'];
                
                foreach ($sales as $sale) {
                    if ($sale['saleStatus'] == 'Concluida') {
                        $cdintegracao = $sale['noteId'];
                        $dtlancamento = DateUtil::getDataDeString($sale['saleDate'], 'd-m-Y H:i:s');
                        $vrlancamento = $sale['saleTotalAmount'];
                        $vracrescimo = $sale['totalDiscountAmount'];
                        $vrdesconto = $sale['totalAmountAddition'];
                        
                        $vrsubtotal1 = $vrvalsubtotal1 = $vrsubtotal2 = $vrvalsubtotal2 = $vrsubtotal3 = $vrvalsubtotal3 = $vrfinal = 0;
                        
                        $this->calculaLancamento(
                            $nrorg, $nrrateio, $vrlancamento, $vracrescimo, $vrdesconto, $vrsubtotal1, $vrvalsubtotal1, $vrsubtotal2, $vrvalsubtotal2, $vrsubtotal3, $vrvalsubtotal3, $vrfinal
                        );
                        
                        $this->addRateiolanc(
                            $nrorg, $nrrateio, $dtlancamento, $vrlancamento, $vracrescimo, $vrdesconto, $vrsubtotal1, $vrsubtotal2, $vrsubtotal3, 
                                  $vrvalsubtotal1, $vrvalsubtotal2, $vrvalsubtotal3, $vrfinal, $cdintegracao
                        );
                        
                        $qtdLancamentos++;
                    }
                }
            } else if (isset($response['success'])) {
                if ($response['success'] == false) {
                    throw new \Exception($response['message']);
                } else {
                    throw new \Exception("Erro ao comunicar com a API {".$response."}");
                }
            } else {
                throw new \Exception("Erro ao comunicar com a API {".$response."}");
            }
            
            return $qtdLancamentos;
        } catch(\Exception $e) {
            throw $e;;
        }  
    }
    
    public function addRateiolanc($nrorg, $nrrateio, $dtlancamento, $vrlancamento, $vracrescimo, $vrdesconto, $vrsubtotal1, $vrsubtotal2, $vrsubtotal3, 
                                  $vrvalsubtotal1, $vrvalsubtotal2, $vrvalsubtotal3, $vrfinal, $cdintegracao)
    {
        $fpaRateiolanc = Repositories::FPA_RATEIOLANC;
        
        if (!is_null($cdintegracao)) {
            $rateiolanc = $this->entityManager->getRepository(Repositories::FPA_RATEIOLANC)->findOneBy(array('nrorg' => $nrorg, 'nrrateio' => $nrrateio, 'cdintegracao' => $cdintegracao));
        } else {
            $rateiolanc = $this->entityManager->getRepository(Repositories::FPA_RATEIOLANC)->findOneBy(array('nrorg' => $nrorg, 'nrrateio' => $nrrateio, 'dtlancamento' => $dtlancamento));
        }
        
        if (is_object($rateiolanc)) {
            $rateiolanc->setVrlancamento($vrlancamento);
            $rateiolanc->setVracrescimo($vracrescimo);
            $rateiolanc->setVrdesconto($vrdesconto);
            $rateiolanc->setVrsubtotal1($vrsubtotal1);
            $rateiolanc->setVrsubtotal2($vrsubtotal2);
            $rateiolanc->setVrsubtotal3($vrsubtotal3);
            $rateiolanc->setVrvalsubtotal1($vrvalsubtotal1);
            $rateiolanc->setVrvalsubtotal2($vrvalsubtotal2);
            $rateiolanc->setVrvalsubtotal3($vrvalsubtotal3);
            $rateiolanc->setVrfinal($vrfinal);
            $rateiolanc->setCdintegracao($cdintegracao);
            
            $rateiolanc->setDtultatu(DateUtil::getDataAtual());
            $rateiolanc->setCdoperultatu($this->hcmParameters->getCdoperador());
            $rateiolanc->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        } else {
            $rateiolanc = new $fpaRateiolanc;
            $rateiolanc->setNrorg($nrorg);
            $rateiolanc->setNrrateio($nrrateio);
            $rateiolanc->setDtlancamento($dtlancamento);
            $rateiolanc->setVrlancamento($vrlancamento);
            $rateiolanc->setVracrescimo($vracrescimo);
            $rateiolanc->setVrdesconto($vrdesconto);
            $rateiolanc->setVrsubtotal1($vrsubtotal1);
            $rateiolanc->setVrsubtotal2($vrsubtotal2);
            $rateiolanc->setVrsubtotal3($vrsubtotal3);
            $rateiolanc->setVrvalsubtotal1($vrvalsubtotal1);
            $rateiolanc->setVrvalsubtotal2($vrvalsubtotal2);
            $rateiolanc->setVrvalsubtotal3($vrvalsubtotal3);
            $rateiolanc->setVrfinal($vrfinal);
            $rateiolanc->setCdintegracao($cdintegracao);
            $rateiolanc->setIdativo('S');
            
            $rateiolanc->setDtinclusao(DateUtil::getDataAtual());
            $rateiolanc->setCdoperinclusao($this->hcmParameters->getCdoperador());
            $rateiolanc->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
            $rateiolanc->setDtultatu(DateUtil::getDataAtual());
            $rateiolanc->setCdoperultatu($this->hcmParameters->getCdoperador());
            $rateiolanc->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        }
        
        //var_dump($rateiolanc);die;
        
        $rateiolanc->setNrrateiolanc(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'FPA_RATEIOLANC', 1, 12, true));
        
        $this->entityManager->persist($rateiolanc);
        $this->entityManager->flush();
        
        return $rateiolanc;
    }

    public function exportaLote($itens, $nrorg, $dtmescompetenc, $nreventom)
    {   
        foreach($itens as $item) {
            $itensLote[] = array(
                'NRVINCULOM' => $item['NRVINCULOM'],
                'NMVINCULOM' => '',
                'NREVENTOM' => $nreventom,
                'NMEVENTOH' => '',
                'VRREFFOLHALOTE' => null,
                'VREVENTOLOTE' => $item['VRVALOR']
            );
        }

        $lote = $this->loteLancEventoService->geraLoteLancEvento(
            $nrorg, $dtmescompetenc, 'FPA', 'EXPORTAÇÃO DO RATEIO DE LANÇAMENTO', 'PENDENTE', '', 1,  $itensLote
        );

    }

    public function validaQntdVinculosParaRateio($qntdVinculosEstrutGerenCargo, $estrutgeren, $ocupacao)
    {
        foreach ($qntdVinculosEstrutGerenCargo as $item) {
            if ($estrutgeren == $item['NRESTRUTGEREN'] && $ocupacao == $item['NRCARGO']) {
                $qntdVinculosRateio = $item['QNTDVINCULOS']; 
                return $qntdVinculosRateio;
            }
        }
        
    }

    public function calculaRateio($vrFinalLancamento, $porcentagemEstrutGeren, $porcentagemOcupacao, $qntdVinculosRateio)
    {
        try {
            $resultado = ($vrFinalLancamento * ($porcentagemEstrutGeren/100)) * ($porcentagemOcupacao/100);
            $resultado = $resultado/$qntdVinculosRateio;
            return $resultado;
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }  
    }

    public function calculaPorcentagem($nrorg, $nrrateio, $tabela)
    {
       if($tabela == 'FPA_RATEIOESTRUT') {
           $porcentagens = $this->rateioLancamentoRepository->selectPorcentagemEstrutura($nrorg, $nrrateio);
           foreach($porcentagens as $porcentagem) {
            $this->rateioLancamentoRepository->setPorcentagemEstrutura($nrorg, $nrrateio, $porcentagem['NRRATEIOESTRUT'],$porcentagem['PERCENT']);
           }
       } 

       if($tabela == 'FPA_RATEIOOCUP') {
           $porcentagens = $this->rateioLancamentoRepository->selectPorcentagemOcupacao($nrorg, $nrrateio);
           foreach($porcentagens as $porcentagem) {
               $this->rateioLancamentoRepository->setPorcentagemOcupacao($nrorg, $nrrateio, $porcentagem['NRRATEIOOCUP'],$porcentagem['PERCENT']);
           }
       }    
   }

   public function existeItensRateio($nrorg, $nrrateio)
    {
        $existeItemEstrutura =  $this->rateioLancamentoRepository->selectExisteItensRateio($nrorg, $nrrateio, 'FPA_RATEIOESTRUT');
        $existeItemLancamento =  $this->rateioLancamentoRepository->selectExisteItensRateio($nrorg, $nrrateio, 'FPA_RATEIOLANC');
        $existeItemOcupacao = $this->rateioLancamentoRepository->selectExisteItensRateio($nrorg, $nrrateio, 'FPA_RATEIOOCUP' );
        if($existeItemEstrutura || $existeItemLancamento || $existeItemOcupacao) {
            return true;
        }

        return false;
    }

    public function calculaLancamento($nrorg, $nrrateio, $vrlancamento, $vracrescimo, $vrdesconto, &$vrsubtotal1, &$vrvalsubtotal1, &$vrsubtotal2, &$vrvalsubtotal2, &$vrsubtotal3, &$vrvalsubtotal3, &$vrfinal)
    {   
        $rateio = $this->entityManager->getRepository(Repositories::FPA_RATEIO)->findOneBy(array('nrrateio' => $nrrateio, 'nrorg' => $nrorg)); 
        
        $vrlancamento = self::aplicaAcrescimoDesconto($vrlancamento, $vracrescimo, $vrdesconto);
        
        $subtotal = null;
        
        if($rateio->getDsoperacao1() != null) {
            $vrsubtotal1 = self::calculaSubTotal($vrlancamento, $rateio->getVrtaxa1()); 
            $subtotal = self::calculaVrFinalLancamento($vrlancamento, $vrsubtotal1, $rateio->getDsoperacao1());
            $vrvalsubtotal1 = $subtotal;
        } else {
            $vrsubtotal1 = null;
            $vrvalsubtotal1 = null;
        }

        if($rateio->getDsoperacao2() != null) {   
            $lancamento = !is_null($subtotal) ? $subtotal : $vrlancamento;
            $vrsubtotal2 = self::calculaSubTotal($lancamento, $rateio->getVrtaxa2()); 
            $subtotal = self::calculaVrFinalLancamento($lancamento, $vrsubtotal2, $rateio->getDsoperacao2());
            $vrvalsubtotal2 = $subtotal;
        } else {
            $vrsubtotal2 = null;
            $vrvalsubtotal2 = null;
        }


        if($rateio->getDsoperacao3() != null) {
            $lancamento = !is_null($subtotal) ? $subtotal : $vrlancamento;
            $vrsubtotal3 = self::calculaSubTotal($lancamento, $rateio->getVrtaxa3()); 
            $subtotal = self::calculaVrFinalLancamento($lancamento, $vrsubtotal3, $rateio->getDsoperacao3());
            $vrvalsubtotal3 = $subtotal;
        } else {
            $vrsubtotal3 = null;
            $vrvalsubtotal3 = null;
        }
        
        if($subtotal == null) {
            $vrfinal = $vrlancamento;
            return;
        }

        $vrfinal = $subtotal;
        return;
    }

    private static function calculaSubTotal($vrlancamento, $taxa)
    {   
        $resultado = ($vrlancamento * ($taxa/100));
        return $resultado;
    }

    private static function calculaVrFinalLancamento($vrlancamento, $vrsubtotal, $operação)
    {   
        if($operação == 'SOMA') {
            $resultado = $vrlancamento + $vrsubtotal;
            return $resultado;
        }

        if($operação == 'SUBTRAI') {
            $resultado = $vrlancamento - $vrsubtotal;
            return $resultado;
        }      
    }

    private static function aplicaAcrescimoDesconto($vrlancamento, $vracrescimo, $vrdesconto)
    {    
        if($vracrescimo != null) {
            $vrlancamento = $vrlancamento + floatval($vracrescimo);
        }

        if($vrdesconto != null) {
            $vrlancamento = $vrlancamento - floatval($vrdesconto);
        }
        
        return $vrlancamento;
    }
}