<?php

namespace HCM\PTO\Logic\AFD\Portaria671;

/**
 * Portaria 671
 * Responsavel por permitir a contagem de registros processados da portaria
 * 
 */

use HCM\Util\Util;
use HCM\PTO\Logic\AFD\ContadorRegistros as ContadorRegistrosAFD;

class ContadorRegistros extends ContadorRegistrosAFD {
    /**
     * Portaria 671
     * Responsavel por filtrar os registros do arquivo por tipos especificos
     * @return int
     */
    public function buscaRegistrosPorTipo(int $numeroTipoRegistro): array {
        return array_filter($this->getRegistros(), function ($registro) use ($numeroTipoRegistro) {
            switch ($numeroTipoRegistro) {
                case 7:
                    return $registro instanceof RegistroMarcacao;
                default:
                    return false;
            }
        });
    }
}