<?php
namespace HCM\PTO\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;

use HCM\Util\Util;

class ResumosGeraisApuracaoRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
    }

    /**
     * @return array
     */
    public function getResumosGeraisApuracaoDiario($dataset) {
        $nrorg = $dataset['NRORGTRAB'];
        $nrperiodoapuracao = $dataset['NRPERIODOAPURACAO'];
        $dtiniperiodoapuracao = explode(' ', $dataset['DTINICIALAPURACAO'])[0];
        $dtfimperiodoapuracao = explode(' ', $dataset['DTFINALAPURACAO'])[0];
        $filter = '';
        if(array_key_exists('NRVINCULOM_LIST', $dataset) && !empty($dataset['NRVINCULOM_LIST'])){
            $nrvinculom = implode(",", $dataset['NRVINCULOM_LIST']);
            if(empty($filter)){
                $filter = "AND GPE_VINCULOM.NRVINCULOM IN ($nrvinculom)";
            } else {
                $filter .= " AND GPE_VINCULOM.NRVINCULOM IN ($nrvinculom)";
            }
        }

        if(array_key_exists('LIST_NRESTRUTLEGAL', $dataset) && !empty($dataset['LIST_NRESTRUTLEGAL'])){
            $nrestruturalegal = implode(",", $dataset['LIST_NRESTRUTLEGAL']);
            if(empty($filter)){
                $filter = "AND GPE_VINCULOH.NRESTRUTLEGAL IN ($nrestruturalegal)";
            } else {
                $filter .= " AND GPE_VINCULOH.NRESTRUTLEGAL IN ($nrestruturalegal)";
            }
        }

        if(array_key_exists('LIST_NRESTRUTGEREN', $dataset) && !empty($dataset['LIST_NRESTRUTGEREN'])){
            $nrestruturagerencial = implode(",", $dataset['LIST_NRESTRUTGEREN']);
            if(empty($filter)){
                $filter = "AND GPE_VINCULOH.NRESTRUTGEREN IN ($nrestruturagerencial)";
            } else {
                $filter .= " AND GPE_VINCULOH.NRESTRUTGEREN IN ($nrestruturagerencial)";
            }
        }
        
        $query = "
                SELECT
                    *
                  FROM (SELECT
                          TO_CHAR (VINCULOS.DTDATA, 'YYYY/MM/DD') DATE_ORDER,
                          TO_CHAR (VINCULOS.DTDATA, 'DD') DIA_MES,
                          TO_CHAR (VINCULOS.DTDATA, 'MM') MES,
                          REPLACE(TO_CHAR (VINCULOS.DTDATA, 'DD/MM/YYYY') || ' - ' || INITCAP(VINCULOS.DIA), '-Feira') DTAPURACAOSITUFREQ,
                          PRINCIPAL.TRAB_DIURNO_I,
                          PRINCIPAL.TRAB_NOTURNO_I,
                          PRINCIPAL.TRAB_TOTAL,
                          PRINCIPAL.SALDO_A_FOLGAR_NORMAL,
                          PRINCIPAL.SALDO_FOLGAR_PER_BHR_NORM,
                          PRINCIPAL.SALDO_FOLGAR_ACR_PER_BHR_NORM,
                          PRINCIPAL.EX_DIA_NORMAL,
                          PRINCIPAL.EX_DIA_NORMAL_NP,
                          PRINCIPAL.EX_NOT_NORMAL,
                          PRINCIPAL.EX_NOT_NORMAL_NP,
                          PRINCIPAL.ATRASOS_DIURNOS,
                          PRINCIPAL.ATRASOS_NOTURNOS,
                          PRINCIPAL.FALTAS_DIURNAS,
                          PRINCIPAL.FALTAS_NOTURNAS,
                          PRINCIPAL.EX_DIA_FERIAD,
                          PRINCIPAL.EX_NOT_FERIAD,
                          
                          -- CASE PARA NÃO MOSTRAR FALTAS_TOTAL CASO SEJA 0, IGUAL ÀS FALTAS DIRUNAS E NOTURNAS
                          CASE PRINCIPAL.FALTAS_TOTAL
                            WHEN 0 THEN NULL
                            ELSE PRINCIPAL.FALTAS_TOTAL
                          END AS FALTAS_TOTAL,
                          
                          VINCULOS.NMVINCULOM,
                          VINCULOS.NRVINCULOM,
                          PRINCIPAL.NRPERIODOAPURACAO
                        FROM
                        (SELECT
                          DTAPURACAOSITUFREQ DATA_APURACAO,
                          TO_CHAR (DTAPURACAOSITUFREQ, 'DD') DIA_MES,
                          TO_CHAR (DTAPURACAOSITUFREQ, 'MM') MES,
                          TRAB_DIURNO_I,
                          TRAB_NOTURNO_I,
                          
                          NVL(TRAB_DIURNO_I, 0) + NVL(TRAB_NOTURNO_I, 0) AS TRAB_TOTAL,
                          
                          SALDO_A_FOLGAR_NORMAL,
                          SALDO_FOLGAR_PER_BHR_NORM,
                          SALDO_FOLGAR_ACR_PER_BHR_NORM,
                          NVL(EX_DIA_NORMAL_1AS, 0) + NVL(EX_DIA_NORMAL_SEG, 0)  EX_DIA_NORMAL,
                          NVL(EX_DIA_NORMAL_NP_1AS, 0) + NVL(EX_DIA_NORMAL_NP_SEG, 0) EX_DIA_NORMAL_NP,
                          NVL(EX_NOT_NORMAL_1AS, 0) + NVL(EX_NOT_NORMAL_SEG, 0) EX_NOT_NORMAL,
                          NVL(EX_NOT_NORMAL_NP_1AS, 0) + NVL(EX_NOT_NORMAL_NP_SEG, 0) EX_NOT_NORMAL_NP,
                          ATRASOS_DIURNOS,
                          ATRASOS_NOTURNOS,
                          FALTAS_DIURNAS,
                          FALTAS_NOTURNAS,
                          NVL(EX_DIA_FERIAD_1AS, 0) + NVL(EX_DIA_FERIAD_SEG, 0) EX_DIA_FERIAD,
                          NVL(EX_NOT_FERIAD_1AS, 0) + NVL(EX_NOT_FERIAD_SEG, 0) EX_NOT_FERIAD,
                          
                          NVL(FALTAS_DIURNAS, 0) + NVL(FALTAS_NOTURNAS, 0) AS FALTAS_TOTAL,
                          
                          NMVINCULOM,
                          NRVINCULOM,
                          NRPERIODOAPURACAO
                        FROM (
                            SELECT * FROM (
                                SELECT DTAPURACAOSITUFREQ, NVL(ASF.NRCALCULOSITUFREQ, PTO_RESUMOSITUFREQ.NRSITUFREQUENCIA) NRCALCULOSITUFREQ, (ROUND(QTREFAPURSITUFREQ, 2)) QTREFAPURSITUFREQ,
                                       (SELECT DTCALENDARIO
                                          FROM OCORCALENDARIO
                                         WHERE NRCALENDARIO = 1
                                           AND NRORG = :P_NRORG
                                           AND DTCALENDARIO = DTAPURACAOSITUFREQ) IS_FERIADO,
                                       VM.NMVINCULOM,
                                       VM.NRVINCULOM,
                                       NRPERIODOAPURACAO
                                  FROM PTO_RESUMOSITUFREQ
                                  JOIN GPE_VINCULOM VM
                                    ON VM.NRVINCULOM = PTO_RESUMOSITUFREQ.NRVINCULOM
                                   AND VM.NRORG      = PTO_RESUMOSITUFREQ.NRORG
                                   
                                  /*BUSCA O CALCULO DE FREQUENCIA ASSOCIADO A SITUACAO PARA TRATAR CASOS QUE EXISTEM SITUACOES CUSTOMIZADAS*/
                                  LEFT JOIN PTO_ASSOCSITUFREQ ASF
                                    ON ASF.NRSITUFREQUENCIA = PTO_RESUMOSITUFREQ.NRSITUFREQUENCIA
                                    /* BUSCA DE RELACOES DA ORG DO CLIENTE OU (EXCLUSIVAMENTE) DA ORG PADRAO */
                                    AND ASF.NRORG = (
                                        SELECT NRORG
                                        FROM PTO_ASSOCSITUFREQ
                                        WHERE NRSITUFREQUENCIA = ASF.NRSITUFREQUENCIA
                                            AND (NRORG = :P_NRORG OR NRORG = :P_NRORG_PADRAO)
                                        GROUP BY NRORG
                                        ORDER BY (
                                            CASE
                                                WHEN NRORG = :P_NRORG AND COUNT(NRORG) = 1 THEN -1
                                                ELSE NRORG
                                            END
                                        )
                                        FETCH FIRST ROW ONLY
                                    )
                                    /* GARANTE QUE APENAS UMA ASSOCIACAO SERA ESCOLHIDA */
                                    AND ASF.NRASSOCSITUFREQ = (
                                        SELECT MAX(NRASSOCSITUFREQ)
                                        FROM PTO_ASSOCSITUFREQ
                                        WHERE NRORG = ASF.NRORG
                                            AND NRSITUFREQUENCIA = ASF.NRSITUFREQUENCIA
                                    )
                                  /**/
                                  
                                 WHERE PTO_RESUMOSITUFREQ.NRPERIODOAPURACAO = :P_NRPERIODOAPURACAO
                                   AND PTO_RESUMOSITUFREQ.NRORG             = :P_NRORG
                            ) PTO_RESUMOSITUFREQ
                        ) PIVOT (SUM(QTREFAPURSITUFREQ) FOR NRCALCULOSITUFREQ IN (100 TRAB_DIURNO_I, 300 TRAB_NOTURNO_I, 18000 SALDO_A_FOLGAR_NORMAL, 18020 SALDO_FOLGAR_PER_BHR_NORM, 18420 SALDO_FOLGAR_ACR_PER_BHR_NORM, 2000 EX_DIA_NORMAL_NP_1AS, 2100 EX_DIA_NORMAL_NP_SEG, 2200 EX_DIA_NORMAL_1AS, 2300 EX_DIA_NORMAL_SEG, 2600 EX_NOT_NORMAL_NP_1AS, 2700 EX_NOT_NORMAL_NP_SEG, 2900 EX_NOT_NORMAL_1AS, 3000 EX_NOT_NORMAL_SEG, 10100 ATRASOS_DIURNOS, 10200 ATRASOS_NOTURNOS, 10500 FALTAS_DIURNAS, 10600 FALTAS_NOTURNAS, 6700 EX_DIA_FERIAD_1AS, 6800 EX_DIA_FERIAD_SEG, 7400 EX_NOT_FERIAD_1AS, 7500 EX_NOT_FERIAD_SEG))

                        ORDER BY MES, DIA_MES) PRINCIPAL
                        RIGHT JOIN (SELECT
                                      DTDATA,
                                      GPE_VINCULOM.NRORG,
                                      GPE_VINCULOM.NRVINCULOM,
                                      GPE_VINCULOM.NMVINCULOM,
                                       TO_CHAR(DTDATA, 'DAY', 'NLS_DATE_LANGUAGE = PORTUGUESE') AS DIA
                                FROM DATA, GPE_VINCULOM
                                INNER JOIN GPE_VINCULOH
                                    ON GPE_VINCULOH.NRVINCULOM      = GPE_VINCULOM.NRVINCULOM
                                    AND GPE_VINCULOH.NRORG          = GPE_VINCULOM.NRORG
                                    AND GPE_VINCULOH.DTMESCOMPETENC = (SELECT MAX(VH.DTMESCOMPETENC)
                                                                      FROM GPE_VINCULOH VH
                                                                      WHERE VH.NRORG      = GPE_VINCULOH.NRORG
                                                                      AND VH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM)
                                WHERE DTDATA BETWEEN :P_DTINIPERIODOAPURACAO AND :P_DTFIMPERIODOAPURACAO
                                  AND GPE_VINCULOM.NRORG = :P_NRORG
                                  ".$filter."
                                  AND EXISTS (SELECT (1)
                                              FROM PTO_RESUMOSITUFREQ
                                             WHERE NRORG = GPE_VINCULOM.NRORG
                                               AND NRVINCULOM = GPE_VINCULOM.NRVINCULOM
                                               AND QTREFAPURSITUFREQ != '0' /* verificar se pode ser validado dessa forma */
                                               AND DTAPURACAOSITUFREQ BETWEEN TO_DATE(:P_DTINIPERIODOAPURACAO) AND TO_DATE(:P_DTFIMPERIODOAPURACAO) -1)
                                ORDER BY NMVINCULOM, DTDATA) VINCULOS
                          ON VINCULOS.NRVINCULOM = PRINCIPAL.NRVINCULOM
                         AND VINCULOS.DTDATA     = PRINCIPAL.DATA_APURACAO
                         WHERE 1 = 1 ORDER BY VINCULOS.NRVINCULOM DESC) PRINCIPAL
                  WHERE 1 = 1 ORDER BY PRINCIPAL.DATE_ORDER";
        $params = array('P_NRORG'                => $nrorg,
                        'P_NRPERIODOAPURACAO'    => $nrperiodoapuracao,
                        'P_DTINIPERIODOAPURACAO' => $dtiniperiodoapuracao,
                        'P_DTFIMPERIODOAPURACAO' => $dtfimperiodoapuracao,
                        'P_NRORG_PADRAO'         => Util::getHCMParameters()->getNrorgPadrao());
           
        return $this->connection->fetchAll($query, $params);
    }
    
    public function getResumosGeraisApuracaoPeriodo($dataset) {
        $nrorg = $dataset['NRORGTRAB'];
        $nrperiodoapuracao = $dataset['NRPERIODOAPURACAO'];
        $nrtipovinculom = $dataset['NRTIPOVINCULOM'];
        $nrorgPadrao = Util::getHCMParameters()->getNrorgPadrao();
        
        $query = <<<SQL
            WITH VINCULOS AS (
                SELECT
                    VM.NRORG,
                    VM.NRVINCULOM,
                    VM.NMVINCULOM,
                    VH.NRESTRUTLEGAL,
                    VH.NRESTRUTGEREN,
                    VH.NRESCALATRABM,
                    LEGAL.NMESTRUTURAM NMLEGAL,
                    GERENCIAL.NMESTRUTURAM NMGERENCIAL,
                    ESTRUT_CALENDH.NRCALENDARIO,
                    PB.VRCOEFICIENTEACRESCIMO,
                    PA.NRPERIODOAPURACAO,
                    PA.DTINICIALAPURACAO,
                    PA.DTFINALAPURACAO,
                    VM.DTADMISSAOVINC,
                    TRUNC(GREATEST(PA.DTINICIALAPURACAO, VM.DTADMISSAOVINC)) DTINICIALAPURACAO_TRATADA,
                    TRUNC(LEAST(PA.DTFINALAPURACAO, NVL(VM.DTRESCISAOVINC, PA.DTFINALAPURACAO))) DTFINALAPURACAO_TRATADA,
                    NVL(EH.QTHRSEMESCTRABH, 0) * 5 TOTAL_JORNADA,
                    EVH.VRPERCENTUALEVENTO VRPERCENTUAL_EVENTO_A_PAGAR,
                    AE.NRALTESALARIO,
                    AE.VRSALARIO,
                    TPE.DSTPEVENTOCTBL
                FROM GPE_VINCULOM VM
                JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
                AND VH.NRORG = VM.NRORG
                AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC)
                                                        FROM GPE_VINCULOH
                                                    WHERE NRORG      = VH.NRORG
                                                        AND NRVINCULOM = VH.NRVINCULOM)
                
                JOIN (
                    SELECT
                    NRPERIODOAPURACAO,
                    NVL(TO_DATE(:P_DTINICIO, 'DD/MM/YYYY'), DTINICIALAPURACAO) DTINICIALAPURACAO,
                    NVL(TO_DATE(:P_DTFIM, 'DD/MM/YYYY'), DTFINALAPURACAO) DTFINALAPURACAO
                    FROM PTO_PERIODOAPURACAO
                    WHERE NRORG = :P_NRORG
                ) PA ON PA.NRPERIODOAPURACAO = :P_NRPERIODOAPURACAO
                    
                JOIN ESTRUTURAM LEGAL
                    ON LEGAL.NRESTRUTURAM = VH.NRESTRUTLEGAL
                AND LEGAL.NRORG        = VM.NRORG
                LEFT JOIN ESTRUTURAM GERENCIAL
                    ON GERENCIAL.NRESTRUTURAM = VH.NRESTRUTGEREN
                AND GERENCIAL.NRORG        = VM.NRORG

                JOIN ESTRUTURAM ESTRUT_CALEND ON ESTRUT_CALEND.NRORG = VM.NRORG
                    AND ESTRUT_CALEND.NRESTRUTURAM = NVL((
                        SELECT MOV.NRESTRUTURAM
                        FROM GPE_MOVIMENTACAO MOV
                        JOIN GPE_PARAMORG PO ON PO.NRORG = MOV.NRORG
                            AND PO.NRTPESTRUTCALEND IS NOT NULL
                        WHERE MOV.NRORG = ESTRUT_CALEND.NRORG
                            AND MOV.NRVINCULOM = VM.NRVINCULOM
                            AND MOV.DTINIMOVIMENT <= LAST_DAY(PA.DTFINALAPURACAO)
                            AND (MOV.DTFIMMOVIMENT IS NULL OR MOV.DTFIMMOVIMENT > LAST_DAY(PA.DTFINALAPURACAO))
                            AND MOV.NRTIPOESTRUTURA = PO.NRTPESTRUTCALEND
                        ORDER BY MOV.DTINIMOVIMENT DESC
                        FETCH FIRST ROW ONLY
                        ), VH.NRESTRUTLEGAL)

                LEFT JOIN ESTRUTURAH ESTRUT_CALENDH ON ESTRUT_CALENDH.NRORG = VM.NRORG AND ESTRUT_CALENDH.NRESTRUTURAM = ESTRUT_CALEND.NRESTRUTURAM
                    AND ESTRUT_CALENDH.DTMESCOMPETENC = (
                        SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH WHERE NRORG = ESTRUT_CALENDH.NRORG AND NRESTRUTURAM = ESTRUT_CALENDH.NRESTRUTURAM AND DTMESCOMPETENC <= PA.DTFINALAPURACAO
                    )
                /* ASSOCIACAO CONTABIL */
                LEFT JOIN FPA_TPEVENTOCTBL TPE ON TPE.NRTPEVENTOCTBL = GERENCIAL.NRTPEVENTOCTBL
                    AND (TPE.NRORG = GERENCIAL.NRORG OR TPE.NRORG = 0)
                LEFT JOIN PTO_ALTEBANCOHORAS AB ON AB.NRORG = VM.NRORG AND AB.NRVINCULOM = VM.NRVINCULOM
                    AND AB.DTINICIOALTEBHORAS = (
                        SELECT MAX(DTINICIOALTEBHORAS) FROM PTO_ALTEBANCOHORAS WHERE NRORG = AB.NRORG AND NRVINCULOM = AB.NRVINCULOM
                            AND (DTINICIOALTEBHORAS <= PA.DTFINALAPURACAO AND NVL(DTFIMALTEBHORAS, PA.DTINICIALAPURACAO) >= PA.DTINICIALAPURACAO)
                    )
                LEFT JOIN PTO_BANCOHORASPROG PB ON PB.NRORG = VM.NRORG AND PB.NRBANCOHORAS = AB.NRBANCOHORAS
                    /* TIPO 'Autorizar horas a folgar com acrescimo' */
                    AND PB.NRTIPOPROGOCORRENCIA = 12
                    AND PB.IDATIVO = 'S'
                    AND (PB.DTINICIOPROGBHORAS <= PA.DTFINALAPURACAO AND NVL(PB.DTFIMPROGBHORAS, PA.DTINICIALAPURACAO) >= PA.DTINICIALAPURACAO)

                LEFT JOIN PTO_ASSOCSITUFREQ ASF_QUITA_BANCO
                    ON ASF_QUITA_BANCO.NRCALCULOSITUFREQ = 8000
                    /* BUSCA DE RELACOES DA ORG DO CLIENTE OU (EXCLUSIVAMENTE) DA ORG PADRAO */
                    AND ASF_QUITA_BANCO.NRORG = (
                        SELECT NRORG
                        FROM PTO_ASSOCSITUFREQ
                        WHERE NRCALCULOSITUFREQ = ASF_QUITA_BANCO.NRCALCULOSITUFREQ
                            AND (NRORG = :P_NRORG OR NRORG = :P_NRORG_PADRAO)
                        GROUP BY NRORG
                        ORDER BY (
                            CASE
                                WHEN NRORG = :P_NRORG AND COUNT(NRORG) = 1 THEN -1
                                ELSE NRORG
                            END
                        )
                        FETCH FIRST ROW ONLY
                    )
                    /* GARANTE QUE APENAS UMA ASSOCIACAO SERA ESCOLHIDA */
                    AND ASF_QUITA_BANCO.NRASSOCSITUFREQ = (
                        SELECT MAX(NRASSOCSITUFREQ)
                        FROM PTO_ASSOCSITUFREQ
                        WHERE NRORG = ASF_QUITA_BANCO.NRORG
                            AND NRCALCULOSITUFREQ = ASF_QUITA_BANCO.NRCALCULOSITUFREQ
                    )

                LEFT JOIN PTO_SITUFREQPARAM SFP_QUITA_BANCO ON (SFP_QUITA_BANCO.NRORG = VM.NRORG OR SFP_QUITA_BANCO.NRORG = :P_NRORG_PADRAO)
                    AND SFP_QUITA_BANCO.NRSITUFREQUENCIA = ASF_QUITA_BANCO.NRSITUFREQUENCIA

                /* JOIN MODIFICADO POR RAZOES DE PERFORMANCE. O EVENTO '10 - Sal�rio M�s' EH BUSCADO CASO NAO EXISTA EVENTO DE QUITACAO.
                    EH DE CONHECIMENTO QUE ESTE EVENTO NAO POSSUI VALOR PERCENTUAL, POR ISSO NAO RETORNARA ESSE VALOR CASO NAO EXISTA EVENTO DE QUITACAO.
                    JOIN AO INVES DE LEFT JOIN NESSA TABELA RESULTA EM UMA OTIMIZACAO CONSIDERAVEL
                */
                JOIN FPA_EVENTOH EVH ON (EVH.NRORG = VM.NRORG OR EVH.NRORG = :P_NRORG_PADRAO)
                    AND EVH.NREVENTOM = NVL(SFP_QUITA_BANCO.NREVENTOM, 10)
                    AND EVH.DTMESCOMPETENC = (
                        SELECT MAX(DTMESCOMPETENC)
                        FROM FPA_EVENTOH
                        WHERE NRORG = EVH.NRORG
                        AND NREVENTOM = EVH.NREVENTOM
                    )

                /* SALARIO */
                LEFT JOIN GPE_ALTESALARIO AE ON AE.NRORG = VM.NRORG
                    AND AE.NRVINCULOM = VM.NRVINCULOM
                    AND AE.DTALTESALARIO = (
                    SELECT MAX(DTALTESALARIO)
                    FROM GPE_ALTESALARIO
                    WHERE NRORG = AE.NRORG
                        AND NRVINCULOM = AE.NRVINCULOM
                    )

                /* ESCALA */
                LEFT JOIN GPE_ESCALATRABH EH ON EH.NRORG = VM.NRORG
                    AND EH.NRESCALATRABM = VH.NRESCALATRABM
                    AND EH.DTMESCOMPETENC = (
                    SELECT MAX(DTMESCOMPETENC)
                    FROM GPE_ESCALATRABH
                    WHERE NRORG = EH.NRORG
                        AND NRESCALATRABM = EH.NRESCALATRABM
                    )

                WHERE VM.NRORG = :P_NRORG
                    AND EXISTS (
                        SELECT 1
                        FROM PTO_RESUMOSITUFREQ
                        WHERE NRORG = VM.NRORG
                            AND NRVINCULOM = VM.NRVINCULOM
                            AND NRPERIODOAPURACAO = PA.NRPERIODOAPURACAO
                    )
                    AND VM.NRTIPOVINCULOM = :P_NRTIPOVINCULOM
                    AND ( INSTR(',' || :P_NRVINCULOM_LIST    || ',',   ',' || VM.NRVINCULOM      || ',') > 0 OR :P_NRVINCULOM_LIST IS NULL )
                    AND ( INSTR(',' || :P_NRESTRUTLEGAL_LIST || ',',   ',' || VH.NRESTRUTLEGAL   || ',') > 0 OR :P_NRESTRUTLEGAL_LIST IS NULL )
                    AND ( INSTR(',' || :P_NRESTRUTGEREN_LIST || ',',   ',' || VH.NRESTRUTGEREN   || ',') > 0 OR :P_NRESTRUTGEREN_LIST IS NULL )
                )

                SELECT
                    PTO_RESUMOSITUFREQ.NRVINCULOM,
                    PTO_RESUMOSITUFREQ.NMVINCULOM,
                    PTO_RESUMOSITUFREQ.NRPERIODOAPURACAO,
                    PTO_RESUMOSITUFREQ.NRESTRUTLEGAL,
                    PTO_RESUMOSITUFREQ.NMLEGAL || ' - ' || PTO_RESUMOSITUFREQ.NRESTRUTLEGAL NRESTRUTLEGAL__LABEL,
                    PTO_RESUMOSITUFREQ.NRESTRUTGEREN,
                    PTO_RESUMOSITUFREQ.NMGERENCIAL || ' - ' || PTO_RESUMOSITUFREQ.NRESTRUTGEREN NRESTRUTGEREN__LABEL,
                    DECODE(PTO_RESUMOSITUFREQ.SALDO_FOLGAR_PER_BHR_NORM,     NULL, '0000', PTO_RESUMOSITUFREQ.SALDO_FOLGAR_PER_BHR_NORM) SALDO_FOLGAR_PER_BHR_NORM,
                    DECODE(PTO_RESUMOSITUFREQ.SALDO_FOLGAR_ACR_PER_BHR_NORM, NULL, '0000', PTO_RESUMOSITUFREQ.SALDO_FOLGAR_ACR_PER_BHR_NORM) SALDO_FOLGAR_ACR_PER_BHR_NORM,
                    DECODE(PTO_RESUMOSITUFREQ.SALDO_FOLGAR_ACR_PER_BHR_NORM, NULL, '0000', 
                        PTO_RESUMOSITUFREQ.SALDO_FOLGAR_ACR_PER_BHR_NORM / (1 + (NVL(VRCOEFICIENTEACRESCIMO, 0) / 100)) ) SALDO_FOLGAR_ACR_PER_BHR_25,
                    
                    DECODE(PTO_RESUMOSITUFREQ.DSR_DESCONTADO,                NULL, '0000', PTO_RESUMOSITUFREQ.DSR_DESCONTADO) DSR_DESCONTADO,
                    DECODE(PTO_RESUMOSITUFREQ.FALTAS_DIURNAS,                NULL, '0000', PTO_RESUMOSITUFREQ.FALTAS_DIURNAS) FALTAS_DIURNAS,
                    DECODE(PTO_RESUMOSITUFREQ.FALTAS_NOTURNAS,               NULL, '0000', PTO_RESUMOSITUFREQ.FALTAS_NOTURNAS) FALTAS_NOTURNAS,
                    NVL(PTO_RESUMOSITUFREQ.EX_DIA_NORMAL_NP_SEG, 0) + NVL(PTO_RESUMOSITUFREQ.EX_DIA_NORMAL_NP_1AS, 0) + NVL(PTO_RESUMOSITUFREQ.EX_NOT_NORMAL_NP_1AS, 0) + NVL(PTO_RESUMOSITUFREQ.EX_NOT_NORMAL_NP_SEG, 0) EX_NORMAL_NP,
                    NVL(PTO_RESUMOSITUFREQ.EX_DIA_NORMAL_SEG, 0) + NVL(PTO_RESUMOSITUFREQ.EX_DIA_NORMAL_1AS, 0) + NVL(PTO_RESUMOSITUFREQ.EX_NOT_NORMAL_SEG, 0) + NVL(PTO_RESUMOSITUFREQ.EX_NOT_NORMAL_1AS, 0) EX_NORMAL,
                    NVL(PTO_RESUMOSITUFREQ.EX_DIA_FERIAD_1AS, 0) + NVL(PTO_RESUMOSITUFREQ.EX_DIA_FERIAD_SEG, 0) EX_DIA_FERIAD,
                    NVL(PTO_RESUMOSITUFREQ.EX_NOT_FERIAD_1AS, 0) + NVL(PTO_RESUMOSITUFREQ.EX_NOT_FERIAD_SEG, 0) EX_NOT_FERIAD,
                    DECODE(PTO_RESUMOSITUFREQ.ATRASOS_DIURNOS,               NULL, '0000', PTO_RESUMOSITUFREQ.ATRASOS_DIURNOS) ATRASOS_DIURNOS,
                    DECODE(PTO_RESUMOSITUFREQ.ADICIONAL_NOTURNO,             NULL, '0000', PTO_RESUMOSITUFREQ.ADICIONAL_NOTURNO) ADICIONAL_NOTURNO,
                    PTO_RESUMOSITUFREQ.VRSALARIO,
                    SUBSTR(PTO_RESUMOSITUFREQ.DTADMISSAOVINC, 0, 10) AS DTADMISSAOVINC,
                    PTO_RESUMOSITUFREQ.DSTPEVENTOCTBL,
                    
                    ROUND(
                        (GREATEST(PTO_RESUMOSITUFREQ.SALDO_FOLGAR_ACR_PER_BHR_NORM, 0) / RAZAO_ACRESC_SALDO) * ((PTO_RESUMOSITUFREQ.VRSALARIO / GREATEST(PTO_RESUMOSITUFREQ.TOTAL_JORNADA, 1)) * RAZAO_ACRESC_EVEN)
                    , 2) HORAS_BANCO_A_PAGAR,
                    ROUND(
                        (ROUND(
                        (GREATEST(PTO_RESUMOSITUFREQ.SALDO_FOLGAR_ACR_PER_BHR_NORM, 0) / RAZAO_ACRESC_SALDO) * ((PTO_RESUMOSITUFREQ.VRSALARIO / GREATEST(PTO_RESUMOSITUFREQ.TOTAL_JORNADA, 1)) * RAZAO_ACRESC_EVEN)
                        , 2) / GREATEST(PTO_RESUMOSITUFREQ.DIAS_PERIODO - PTO_RESUMOSITUFREQ.DIAS_FOLGA_REFLEXO, 1)) * PTO_RESUMOSITUFREQ.DIAS_FOLGA_REFLEXO
                    , 2) REFLEXO
                FROM (SELECT RESUMOS.NRVINCULOM,
                        VINCULOS.NMVINCULOM,
                        RESUMOS.NRORG,
                        NVL(ASF.NRCALCULOSITUFREQ, RESUMOS.NRSITUFREQUENCIA) NRCALCULOSITUFREQ,
                        NVL(ROUND(QTREFAPURSITUFREQ, 7), '0000') QTREFAPURSITUFREQ,
                        RESUMOS.NRPERIODOAPURACAO,
                        VINCULOS.NRESTRUTLEGAL,
                        VINCULOS.NRESTRUTGEREN,
                        VINCULOS.NRESCALATRABM,
                        VINCULOS.NMLEGAL,
                        VINCULOS.NMGERENCIAL,
                        VINCULOS.NRCALENDARIO,
                        VINCULOS.VRCOEFICIENTEACRESCIMO,
                        (1+(NVL(VINCULOS.VRCOEFICIENTEACRESCIMO, 0)/100)) RAZAO_ACRESC_SALDO,
                        VINCULOS.DTINICIALAPURACAO,
                        VINCULOS.DTFINALAPURACAO,
                        VINCULOS.TOTAL_JORNADA,
                        VINCULOS.VRPERCENTUAL_EVENTO_A_PAGAR,
                        (1+(VINCULOS.VRPERCENTUAL_EVENTO_A_PAGAR/100)) RAZAO_ACRESC_EVEN,
                        VINCULOS.VRSALARIO,
                        VINCULOS.DTADMISSAOVINC,
                        VINCULOS.DSTPEVENTOCTBL,
                        
                        /*SITUACOES QUE NAO SAO SOMADAS, SAO CONTADAS OU O ULTIMO REGISTRO EH O QUE IMPORTA*/
                        /*SALDO_FOLGAR_PER_BHR_NORM*/
                        (SELECT NVL(ROUND(QTREFAPURSITUFREQ, 7), '0000')
                            FROM (SELECT QTREFAPURSITUFREQ
                                    FROM PTO_RESUMOSITUFREQ RS
                                    JOIN PTO_ASSOCSITUFREQ ASF ON ASF.NRSITUFREQUENCIA = RS.NRSITUFREQUENCIA
                                                            AND ASF.NRCALCULOSITUFREQ = 18020
                                    WHERE RS.NRVINCULOM        = RESUMOS.NRVINCULOM
                                    AND RS.NRPERIODOAPURACAO = :P_NRPERIODOAPURACAO
                                    AND RS.NRORG             = :P_NRORG
                                    AND RS.DTAPURACAOSITUFREQ BETWEEN VINCULOS.DTINICIALAPURACAO AND VINCULOS.DTFINALAPURACAO
                                ORDER BY DTAPURACAOSITUFREQ DESC)
                            WHERE ROWNUM = 1) AS SALDO_FOLGAR_PER_BHR_NORM,
                            
                        /*SALDO_FOLGAR_ACR_PER_BHR_NORM*/
                        (SELECT NVL(ROUND(QTREFAPURSITUFREQ, 7), '0000')
                            FROM (SELECT QTREFAPURSITUFREQ
                                    FROM PTO_RESUMOSITUFREQ RS
                                    JOIN PTO_ASSOCSITUFREQ ASF ON ASF.NRSITUFREQUENCIA = RS.NRSITUFREQUENCIA
                                                            AND ASF.NRCALCULOSITUFREQ = 18420
                                    WHERE RS.NRVINCULOM        = RESUMOS.NRVINCULOM
                                    AND RS.NRPERIODOAPURACAO = :P_NRPERIODOAPURACAO
                                    AND RS.NRORG             = :P_NRORG
                                    AND RS.DTAPURACAOSITUFREQ BETWEEN VINCULOS.DTINICIALAPURACAO AND VINCULOS.DTFINALAPURACAO
                                ORDER BY DTAPURACAOSITUFREQ DESC)
                            WHERE ROWNUM = 1) AS SALDO_FOLGAR_ACR_PER_BHR_NORM,
                            
                        /*DSR_DESCONTADO*/
                        (SELECT COUNT(QTREFAPURSITUFREQ)
                            FROM PTO_RESUMOSITUFREQ RS
                            JOIN PTO_ASSOCSITUFREQ ASF ON ASF.NRSITUFREQUENCIA = RS.NRSITUFREQUENCIA
                                                    AND ASF.NRCALCULOSITUFREQ = 12100
                            WHERE RS.NRVINCULOM        = RESUMOS.NRVINCULOM
                            AND RS.NRPERIODOAPURACAO = :P_NRPERIODOAPURACAO
                            AND RS.NRORG             = :P_NRORG
                            AND RS.DTAPURACAOSITUFREQ BETWEEN VINCULOS.DTINICIALAPURACAO AND VINCULOS.DTFINALAPURACAO) AS DSR_DESCONTADO,
                            
                        /*FALTAS_DIURNAS*/
                        (SELECT COUNT(QTREFAPURSITUFREQ)
                            FROM PTO_RESUMOSITUFREQ RS
                            JOIN PTO_ASSOCSITUFREQ ASF ON ASF.NRSITUFREQUENCIA = RS.NRSITUFREQUENCIA
                                                    AND ASF.NRCALCULOSITUFREQ = 10500
                            WHERE RS.NRVINCULOM        = RESUMOS.NRVINCULOM
                            AND RS.NRPERIODOAPURACAO = :P_NRPERIODOAPURACAO
                            AND RS.NRORG             = :P_NRORG
                            AND RS.DTAPURACAOSITUFREQ BETWEEN VINCULOS.DTINICIALAPURACAO AND VINCULOS.DTFINALAPURACAO) AS FALTAS_DIURNAS,
                            
                        /*FALTAS_NOTURNAS*/
                        (SELECT COUNT(QTREFAPURSITUFREQ)
                            FROM PTO_RESUMOSITUFREQ RS
                            JOIN PTO_ASSOCSITUFREQ ASF ON ASF.NRSITUFREQUENCIA = RS.NRSITUFREQUENCIA
                                                    AND ASF.NRCALCULOSITUFREQ = 10600
                            WHERE RS.NRVINCULOM        = RESUMOS.NRVINCULOM
                            AND RS.NRPERIODOAPURACAO = :P_NRPERIODOAPURACAO
                            AND RS.NRORG             = :P_NRORG
                            AND RS.DTAPURACAOSITUFREQ BETWEEN VINCULOS.DTINICIALAPURACAO AND VINCULOS.DTFINALAPURACAO) AS FALTAS_NOTURNAS,
                            
                        (SELECT COUNT(OC.DTCALENDARIO) + (TRUNC(VINCULOS.DTFINALAPURACAO_TRATADA+1, 'IW') - TRUNC(VINCULOS.DTINICIALAPURACAO_TRATADA, 'IW')) / 7 /* Quantidade de domingos no periodo */
                            FROM OCORCALENDARIO OC
                            WHERE OC.NRORG = :P_NRORG
                            AND OC.NRCALENDARIO = VINCULOS.NRCALENDARIO
                            AND OC.DTCALENDARIO BETWEEN VINCULOS.DTINICIALAPURACAO_TRATADA AND VINCULOS.DTFINALAPURACAO_TRATADA
                            ) AS DIAS_FOLGA_REFLEXO,
                            GREATEST(VINCULOS.DTFINALAPURACAO_TRATADA - VINCULOS.DTINICIALAPURACAO_TRATADA + 1, 0) DIAS_PERIODO
                    FROM VINCULOS
                    LEFT JOIN PTO_RESUMOSITUFREQ RESUMOS ON RESUMOS.NRORG = VINCULOS.NRORG
                        AND RESUMOS.NRVINCULOM = VINCULOS.NRVINCULOM
                        AND RESUMOS.NRPERIODOAPURACAO = VINCULOS.NRPERIODOAPURACAO
                        AND RESUMOS.DTAPURACAOSITUFREQ BETWEEN VINCULOS.DTINICIALAPURACAO AND VINCULOS.DTFINALAPURACAO
                    
                    /*BUSCA O CALCULO DE FREQUENCIA ASSOCIADO A SITUACAO PARA TRATAR CASOS QUE EXISTEM SITUACOES CUSTOMIZADAS*/
                    LEFT JOIN PTO_ASSOCSITUFREQ ASF
                        ON ASF.NRSITUFREQUENCIA = RESUMOS.NRSITUFREQUENCIA
                        /* BUSCA DE RELACOES DA ORG DO CLIENTE OU (EXCLUSIVAMENTE) DA ORG PADRAO */
                        AND ASF.NRORG = (
                            SELECT NRORG
                            FROM PTO_ASSOCSITUFREQ
                            WHERE NRSITUFREQUENCIA = ASF.NRSITUFREQUENCIA
                                AND (NRORG = :P_NRORG OR NRORG = :P_NRORG_PADRAO)
                            GROUP BY NRORG
                            ORDER BY (
                                CASE
                                    WHEN NRORG = :P_NRORG AND COUNT(NRORG) = 1 THEN -1
                                    ELSE NRORG
                                END
                            )
                            FETCH FIRST ROW ONLY
                        )
                        /* GARANTE QUE APENAS UMA ASSOCIACAO SERA ESCOLHIDA */
                        AND ASF.NRASSOCSITUFREQ = (
                            SELECT MAX(NRASSOCSITUFREQ)
                            FROM PTO_ASSOCSITUFREQ
                            WHERE NRORG = ASF.NRORG
                                AND NRSITUFREQUENCIA = ASF.NRSITUFREQUENCIA
                        )
                ) PIVOT (SUM(QTREFAPURSITUFREQ) FOR NRCALCULOSITUFREQ IN (2000 EX_DIA_NORMAL_NP_1AS, 2100 EX_DIA_NORMAL_NP_SEG, 2200 EX_DIA_NORMAL_1AS, 2300 EX_DIA_NORMAL_SEG, 2600 EX_NOT_NORMAL_NP_1AS, 2700 EX_NOT_NORMAL_NP_SEG, 2900 EX_NOT_NORMAL_1AS, 3000 EX_NOT_NORMAL_SEG, 10100 ATRASOS_DIURNOS, 9000 ADICIONAL_NOTURNO, 6700 EX_DIA_FERIAD_1AS, 6800 EX_DIA_FERIAD_SEG, 7400 EX_NOT_FERIAD_1AS, 7500 EX_NOT_FERIAD_SEG)) PTO_RESUMOSITUFREQ
                ORDER BY PTO_RESUMOSITUFREQ.NRVINCULOM
SQL;

        $params = [
            'P_NRORG' => $nrorg,
            'P_NRORG_PADRAO' => $nrorgPadrao,
            'P_NRPERIODOAPURACAO' => $nrperiodoapuracao,
            'P_NRTIPOVINCULOM' => $nrtipovinculom,
            'P_DTINICIO' => !empty($dataset['DTINICIO']) ? $dataset['DTINICIO'] : null,
            'P_DTFIM' => !empty($dataset['DTFIM']) ? $dataset['DTFIM'] : null,
            'P_NRVINCULOM_LIST' => !empty($dataset['NRVINCULOM_LIST']) ? Util::arrayToStringSeparatedByComma($dataset['NRVINCULOM_LIST'], false) : null,
            'P_NRESTRUTLEGAL_LIST' => !empty($dataset['LIST_NRESTRUTLEGAL']) ? Util::arrayToStringSeparatedByComma($dataset['LIST_NRESTRUTLEGAL'], false) : null,
            'P_NRESTRUTGEREN_LIST' => !empty($dataset['LIST_NRESTRUTGEREN']) ? Util::arrayToStringSeparatedByComma($dataset['LIST_NRESTRUTGEREN'], false) : null,
        ];
        
        return $this->connection->fetchAll($query, $params);
    }
    
    public function getCdoperadorResponsavel($nrpessoa, $nrorg){
        
        $params = array('P_NRPESSOA' => $nrpessoa,
                        'P_NRORG'    => $nrorg);
        $query = "SELECT CDOPERADOR 
                    FROM OPERADOR 
               LEFT JOIN GPE_PESSOA
                      ON OPERADOR.NRPARCNEGOCIO = GPE_PESSOA.NRPARCNEGOCIO
                     AND OPERADOR.NRORG = GPE_PESSOA.NRORG
                   WHERE GPE_PESSOA.NRPESSOA = :P_NRPESSOA
                     AND GPE_PESSOA.NRORG = :P_NRORG";
        
        return $this->connection->fetchAll($query, $params);
        
    }
    
    public function getResumosGeraisApuracaoResponsavel($dataset){
        
        $params = array('P_NRORG'             => $dataset['NRORGTRAB'],
                        'P_NRPERIODOAPURACAO' => $dataset['NRPERIODOAPURACAO'],
                        'P_DTFINALAPURACAO'   => substr($dataset['DTFINALAPURACAO'], 0, 10),
						'P_NRESTRUTLEGAL'     => $dataset['NRESTRUTLEGAL'],
						'P_NRESTRUTGEREN'     => $dataset['NRESTRUTGEREN'],
						'P_NRESTRUTSIND'      => $dataset['NRESTRUTSIND'],
						'P_NRVINCULOM'        => $dataset['NRVINCULOM'],
						'P_OPERADORLIDER'     => $dataset['CDOPERADORRESP'] );
        
        $query = "SELECT PRINCIPAL.*,
                           ESTRUTURAM.NMESTRUTURAM NMESTRUTGEREN,
                    	   PARCNEGOCIO.NMPRINCIPALPARC NMPESSOA	
                      FROM TABLE(BANCOHORAS_DADOS(:P_NRORG, :P_NRPERIODOAPURACAO, :P_DTFINALAPURACAO, :P_NRESTRUTLEGAL, :P_NRESTRUTGEREN, :P_NRESTRUTSIND, :P_NRVINCULOM, :P_OPERADORLIDER)) PRINCIPAL,
                    	   ESTRUTURAM,
                    	   PARCNEGOCIO
                     WHERE ESTRUTURAM.NRORG = :P_NRORG	   
                       AND ESTRUTURAM.NRESTRUTURAM = PRINCIPAL.NRESTRUTGEREN
                       AND PARCNEGOCIO.NRORG = :P_NRORG
                       AND PARCNEGOCIO.NRPARCNEGOCIO = PRINCIPAL.NRPARCLIDER";
	    
    
        return $this->connection->fetchAll($query, $params);
    }
}