<?php

namespace HCM\SST\Services;

use Doctrine\ORM\EntityManager;
use SistemaQualidade\Entities\Clausula;
use SistemaQualidade\Entities\Norma;
use HCM\Util\HCMParameters;

class NormaClausulaService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function deleteNormaClausula($dataset) {
        
        $nrorg = $dataset["NRORG"];
        $cdnorma = $dataset["CDNORMA"];
        $clausula = Clausula::findByCdnormaAndNrorg($cdnorma, $nrorg);
        if (isset($clausula[0])) {
            throw new \Exception("Existe clausula relacionada à esta norma.", 10);
        }
        else {
            $this->entityManager->beginTransaction();
            $norma = Norma::findOneByCdnormaAndNrorg($cdnorma, $nrorg);
            $this->entityManager->remove($norma);
            $this->entityManager->flush();
        }
    }
}