-- ============================================================
-- Table: ESO_AGENTENOCIVO
-- ============================================================
CREATE TABLE ESO_AGENTENOCIVO
(
    NRORG NUMBER NOT NULL,
    NRAGENTENOCIVO NUMBER NOT NULL,
    DSAGENTENOCIVO VARCHAR2(1000) NOT NULL,
    CDESOCIAL VARCHAR2(10) NOT NULL,
    IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL
    CONSTRAINT CKC_IDATIVO_AGENOCIVO CHECK (IDATIVO IN ('N','S')),
    DTINCLUSAO DATE DEFAULT SYSDATE NOT NULL,
    DTULTATU DATE NULL,
    NRORGINCLUSAO NUMBER(22) DEFAULT 1 NULL ,
    CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL ,
    NRORGULTATU NUMBER(22) DEFAULT 1 NULL ,
    CDOPERULTATU VARCHAR2(12) DEFAULT '1' NULL ,
    CONSTRAINT PK_ESO_AGENTENOCIVO PRIMARY KEY (NRAGENTENOCIVO)
)
/

-- ============================================================
-- Table: SST_FATORRISCO
-- ============================================================
ALTER TABLE SST_FATORRISCO ADD NRAGENTENOCIVO NUMBER
/
ALTER TABLE SST_FATORRISCO
    ADD CONSTRAINT FK_FATRIS_AGENOCIVO FOREIGN KEY (NRAGENTENOCIVO)
        REFERENCES ESO_AGENTENOCIVO (NRAGENTENOCIVO)
/

-- ============================================================
-- Table: ESO_AGENTENOCIVO : Inserts
-- ============================================================
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 1, '01.01.001', 'Arsênio e seus compostos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 2, '01.02.001', 'Asbestos (ou amianto)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 3, '01.03.001', 'Benzeno e seus compostos tóxicos (exceto os abaixo especificados, que constam expressamente no Anexo IV do Decreto 3.048/1999)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 4, '01.03.002', 'Estireno (vinilbenzeno)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 5, '01.04.001', 'Berílio e seus compostos tóxicos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 6, '01.05.001', 'Bromo e seus compostos tóxicos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 7, '01.06.001', 'Cádmio e seus compostos tóxicos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 8, '01.07.001', 'Carvão mineral e seus derivados')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 9, '01.08.001', 'Chumbo e seus compostos tóxicos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 10, '01.09.001', 'Cloro e seus compostos tóxicos (exceto os abaixo especificados, que constam expressamente no Anexo IV do Decreto 3.048/1999)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 11, '01.09.002', 'Metileno-ortocloroanilina, MOCA® (4,4-metileno-bis-(2-cloroanilina), MBOCA®)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 12, '01.09.003', 'Bis (cloro metil) éter, clorometileter, (éter bis (clorometílico) ou éter metílico de clorometila)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 13, '01.09.004', 'Biscloroetileter (éter dicloroetílico)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 14, '01.09.005', 'Clorambucil (cloroambucil)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 15, '01.09.006', 'Cloropreno')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 16, '01.10.001', 'Cromo e seus compostos tóxicos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 17, '01.11.001', 'Dissulfeto de carbono')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 18, '01.12.001', 'Fósforo e seus compostos tóxicos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 19, '01.13.001', 'Iodo')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 20, '01.14.001', 'Manganês e seus compostos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 21, '01.15.001', 'Mercúrio e seus compostos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 22, '01.16.001', 'Níquel e seus compostos tóxicos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 23, '01.17.001', 'Petróleo, xisto betuminoso, gás natural e seus derivados')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 24, '01.18.001', 'Sílica livre')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 25, '01.19.001', 'Butadieno-estireno')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 26, '01.19.002', 'Acrilonitrila')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 27, '01.19.003', '1-3-butadieno')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 28, '01.19.004', 'Mercaptanos (tióis)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 29, '01.19.005', 'n-hexano')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 30, '01.19.006', 'Diisocianato de tolueno (TDI)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 31, '01.19.007', 'Aminas aromáticas')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 32, '01.19.008', 'Aminobifenila')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 33, '01.19.009', 'Auramina')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 34, '01.19.010', 'Azatioprina')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 35, '01.19.011', '1-4-butanodiol')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 36, '01.19.012', 'Dimetanosulfonato (MIRELAN)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 37, '01.19.013', 'Ciclofosfamida')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 38, '01.19.014', 'Dietiletil-bestrol')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 39, '01.19.015', 'Acronitrila')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 40, '01.19.016', 'Nitronaftilamina')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 41, '01.19.017', '4-dimetil-aminoazobenzeno')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 42, '01.19.018', 'Benzopireno')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 43, '01.19.019', 'Beta-pbiscloromeropiolactona (beta-propiolactona)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 44, '01.19.020', 'Bisclorometil')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 45, '01.19.021', 'Dianizidina')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 46, '01.19.022', 'Dietilsulfato')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 47, '01.19.023', 'Dimetilsulfato')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 48, '01.19.024', 'Etilenoamina')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 49, '01.19.025', 'Etilenotiureia')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 50, '01.19.026', 'Fenacetina')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 51, '01.19.027', 'Iodeto de metila')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 52, '01.19.028', 'Etilnitrosureia')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 53, '01.19.029', 'Nitrosamina')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 54, '01.19.030', 'Ortotoluidina')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 55, '01.19.031', 'Oximetalona (oxime-talona)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 56, '01.19.032', 'Procarbazina')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 57, '01.19.033', 'Propanosultona')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 58, '01.19.034', 'Óxido de etileno')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 59, '01.19.035', 'Estilbenzeno')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 60, '01.19.036', 'Creosoto')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 61, '01.19.037', '4-aminodifenil')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 62, '01.19.038', 'Benzidina')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 63, '01.19.039', 'Betanaftilamina')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 64, '01.19.040', '1-cloro-2,4-nitrodifenil')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 65, '01.19.041', '3-poxipro-pano')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 66, '02.01.001', 'Ruído')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 67, '02.01.002', 'Vibrações localizadas (mão-braço)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 68, '02.01.003', 'Vibração de corpo inteiro (aceleração resultante de exposição normalizada - aren)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 69, '02.01.004', 'Vibração de corpo inteiro (Valor da Dose de Vibração Resultante - VDVR)')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 70, '02.01.005', 'Trabalhos com perfuratrizes e marteletes pneumáticos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 71, '02.01.006', 'Radiações ionizantes')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 72, '02.01.007', 'Extração e beneficiamento de minerais radioativos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 73, '02.01.008', 'Atividades em minerações com exposição ao radônio')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 74, '02.01.009', 'Realização de manutenção e supervisão em unidades de extração, tratamento e beneficiamento de minerais radioativos com exposição às radiações ionizantes')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 75, '02.01.010', 'Operações com reatores nucleares ou com fontes radioativas')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 76, '02.01.011', 'Trabalhos realizados com exposição aos raios Alfa, Beta, Gama e X, aos nêutrons e às substâncias radioativas para fins industriais, terapêuticos e diagnósticos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 77, '02.01.012', 'Fabricação e manipulação de produtos radioativos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 78, '02.01.013', 'Pesquisas e estudos com radiações ionizantes em laboratórios')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 79, '02.01.014', 'Trabalhos com exposição ao calor acima dos limites de tolerância estabelecidos na NR-15, da Portaria 3.214/1978')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 80, '02.01.015', 'Pressão atmosférica anormal')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 81, '02.01.016', 'Trabalhos em caixões ou câmaras hiperbáricas')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 82, '02.01.017', 'Trabalhos em tubulões ou túneis sob ar comprimido')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 83, '02.01.018', 'Operações de mergulho com o uso de escafandros ou outros equipamentos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 84, '03.01.001', 'Trabalhos em estabelecimentos de saúde com contato com pacientes portadores de doenças infectocontagiosas ou com manuseio de materiais contaminados')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 85, '03.01.002', 'Trabalhos com animais infectados para tratamento ou para o preparo de soro, vacinas e outros produtos')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 86, '03.01.003', 'Trabalhos em laboratórios de autópsia, de anatomia e anátomo-histologia')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 87, '03.01.004', 'Trabalho de exumação de corpos e manipulação de resíduos de animais deteriorados')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 88, '03.01.005', 'Trabalhos em galerias, fossas e tranques de esgoto')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 89, '03.01.006', 'Esvaziamento de biodigestores')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 90, '03.01.007', 'Coleta e industrialização do lixo')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 91, '04.01.001', 'Mineração subterrânea cujas atividades sejam exercidas afastadas das frentes de produção')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 92, '04.01.002', 'Trabalhos em atividades permanentes no subsolo de minerações subterrâneas em frente de produção')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 93, '05.01.001', 'Agentes nocivos não constantes no Anexo IV do Decreto 3.048/1999 e incluídos por força de decisão judicial ou administrativa')
/
INSERT INTO ESO_AGENTENOCIVO (NRORG, NRAGENTENOCIVO, CDESOCIAL, DSAGENTENOCIVO) VALUES (0, 94, '09.01.001', 'Ausência de agente nocivo ou de atividades previstas no Anexo IV do Decreto 3.048/1999')
/