<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 05/06/14
 * Time: 15:41
 */

namespace Folha\Logic\ObrigacaoLegal\RAIS;


use \Geral\Util\AcumuladorDeMensagens;

class Prevalidar
{

    public $acumulador;

    public function __construct($info, $tipo)
    {
        $this->acumulador = AcumuladorDeMensagens::getInstance();

        if ($tipo == 1) {
            foreach($info as $reg)
                $this->valida_01($reg);

        }elseif($tipo == 2){
            foreach($info as $reg)
                $this->valida_02($reg);
        }
    }

    private function valida_01($info)
    {
        //VALIDAR AUSÊNCIAS DE INFORMAÇÃO DO TIPO 01

        $this->validaCdcnpjestrut($info['CDCNPJESTRUT'], $info['NMRAZSOCESTRUT']);
        $this->validaCdceiestrut($info['CDCEIESTRUT'], $info['NMRAZSOCESTRUT']);
        $this->validaNmrazsocestrut($info['NMRAZSOCESTRUT'], $info['CDCNPJESTRUT']);
        $this->validaCdnatujuri($info['CDNATUJURI'], $info['NMRAZSOCESTRUT']);
        $this->validaCdcnae($info['CDCNAE'], $info['NMRAZSOCESTRUT']);
        $this->validaIdoptsimples($info['IDOPTSIMPLES'], $info['NMRAZSOCESTRUT']);
        $this->validaIdparticipat($info['IDPARTICIPAT'], $info['NMRAZSOCESTRUT']);
        $this->validaNrparcnegocio($info['NRPARCNEGOCIO'], $info['NMRAZSOCESTRUT']);
        $this->validaDtbasesindical($info['DTBASESINDICAL'], $info['NMRAZSOCESTRUT']);
        $this->validaCdpais($info['CDPAIS'], $info['NMRAZSOCESTRUT']);
        $this->validaSgestado($info['SGESTADO'], $info['NMRAZSOCESTRUT']);
        $this->validaCdmunicipio($info['CDMUNICIPIO'], $info['NMRAZSOCESTRUT']);
        $this->validaNmbairroendereco($info['NMBAIRROENDERECO'], $info['NMRAZSOCESTRUT']);
        $this->validaNrcependereco($info['NRCEPENDERECO'], $info['NMRAZSOCESTRUT']);
        $this->validaDsendereco($info['DSENDERECO'], $info['NMRAZSOCESTRUT']);
        $this->validaNrimovelendereco($info['NRIMOVELENDERECO'], $info['NMRAZSOCESTRUT']);
        $this->validaDdd($info['DDD'], $info['NMRAZSOCESTRUT']);
        $this->validaTelefone($info['TELEFONE'], $info['NMRAZSOCESTRUT']);
        $this->validaEmail($info['EMAIL'], $info['NMRAZSOCESTRUT']);
        $this->validaNrorg($info['NRORG'], $info['NMRAZSOCESTRUT']);
    }

    private function valida_02($info)
    {
        //VALIDAR AUSÊNCIAS DE INFORMAÇÃO DO TIPO 02
//        $this->validaCdmatricula($info['CDMATRICULA'], $info['NMPESSOA']);
//        $this->validaNmpessoa($info['NMPESSOA'], $info['CDMATRICULA']);
        $this->validaCdestacivil($info['CDESTACIVIL'], $info['CDMATRICULA']);
        $this->validaNranochegapais($info['NRANOCHEGAPAIS'], $info['NRNACIONALID'], $info['CDMATRICULA']);
        $this->validaNrcpfpessoa($info['NRCPFPESSOA'], $info['CDMATRICULA']);
        $this->validaNrpispaseppes($info['NRPISPASEPPES'], $info['CDMATRICULA']);
        $this->validaNrgrauinstr($info['NRGRAUINSTR'], $info['CDMATRICULA']);
        $this->validaNrnacionalid($info['NRNACIONALID'], $info['CDMATRICULA']);
        $this->validaNrrgpessoa($info['NRRGPESSOA'], $info['CDMATRICULA']);
//        $this->validaCdtpbaixapag($info['CDTPBAIXAPAG'], $info['CDMATRICULA']);
        $this->validaDtnascpessoa($info['DTNASCPESSOA'], $info['CDMATRICULA']);
        $this->validaIdsexopessoa($info['IDSEXOPESSOA'], $info['CDMATRICULA']);
        $this->validaDtadmissaovinc($info['DTADMISSAOVINC'], $info['CDMATRICULA']);
//        $this->validaDtrescisaovinc($info['DTRESCISAOVINC'], $info['CDMATRICULA']);
        $this->validaNrtipovinculom($info['NRTIPOVINCULOM'], $info['CDMATRICULA']);
        $this->validaNrvinculoempreg($info['NRVINCULOEMPREG'], $info['CDMATRICULA']);
//        $this->validaIdtppagamento($info['IDTPPAGAMENTO'], $info['CDMATRICULA']);
//        $this->validaNrestrutlega($info['NRESTRUTLEGA'], $info['CDMATRICULA']);
    }
    //
    private function validaNmpessoa($var, $matricula)
    {
        $campo = 'Nome da pessoa';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrorg($var, $matricula)
    {
        $campo = 'Organização';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaCdestacivil($var, $matricula)
    {
        $campo = 'Estado civil';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNranochegapais($var, $nacionalidade, $matricula)
    {
        $campo = 'Ano de chegada ao país';
        if ($nacionalidade != '01') {
            if (is_null($var)) {
                $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
            }
        }
    }

    private function validaNrcpfpessoa($var, $matricula)
    {
        $campo = 'CPF';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrpispaseppes($var, $matricula)
    {
        $campo = 'PIS/PASEP';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrgrauinstr($var, $matricula)
    {
        $campo = 'Grau de instrução';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrnacionalid($var, $matricula)
    {
        $campo = 'Nacionalidade';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrrgpessoa($var, $matricula)
    {
        $campo = 'RG';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaCdtpbaixapag($var, $matricula)
    {
        $campo = 'Tipo de baixa';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaDtnascpessoa($var, $matricula)
    {
        $campo = 'Data de nascimento';
        if(is_null($var)){
            $this->acumulador->addMensagem("rais_validacao_data_nasfpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaIdsexopessoa($var, $matricula)
    {
        $campo = 'Sexo';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaDtadmissaovinc($var, $matricula)
    {
        $campo = 'Data de admissão';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaCdmatricula($var, $pessoa)
    {
        $campo = 'Matricula';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $pessoa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrtipovinculom($var, $matricula)
    {
        $campo = 'Tipo de vínculo';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrvinculoempreg($var, $matricula)
    {
        $campo = 'Tipo de vínculo';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaIdtppagamento($var, $matricula)
    {
        $campo = 'Tipo de pagamento';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrestrutlega($var, $matricula)
    {
        $campo = 'Estrutura legal';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo02", array($campo, $matricula), \Geral\Util\Mensagem::ERRO);
        }
    }

    //VALIDA INFORMAÇÃO TIPO 01

    private function validaCdcnpjestrut($var, $empresa)
    {
        $campo = 'CNPJ';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaCdceiestrut($var, $empresa)
    {
        $campo = 'CEI';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNmrazsocestrut($var, $empresa)
    {
        $campo = 'Razão Social';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaCdnatujuri($var, $empresa)
    {
        $campo = 'Natureza Jurídica';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaCdcnae($var, $empresa)
    {
        $campo = 'CNAE';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaIdtipoempr($var, $empresa)
    {
        $campo = 'Tipo de empresa';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaIdoptsimples($var, $empresa)
    {
        $campo = 'Optante simples';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaIdparticipat($var, $empresa)
    {
        $campo = 'Participa do PAT';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrparcnegocio($var, $empresa)
    {
        $campo = 'Endereço e formas de comunicação';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaDtbasesindical($var, $empresa)
    {
        $campo = 'Data base';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaCdsindical($var, $empresa)
    {
        $campo = 'Sindicato';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaCdpais($var, $empresa)
    {
        $campo = 'País';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaSgestado($var, $empresa)
    {
        $campo = 'Estado';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaCdmunicipio($var, $empresa)
    {
        $campo = 'Municipio';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNmbairroendereco($var, $empresa)
    {
        $campo = 'Bairro';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrcependereco($var, $empresa)
    {
        $campo = 'CEP';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaDsendereco($var, $empresa)
    {
        $campo = 'Endereço';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrimovelendereco($var, $empresa)
    {
        $campo = 'Número do imóvel';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaDdd($var, $empresa)
    {
        $campo = 'DDD';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaTelefone($var, $empresa)
    {
        $campo = 'Telefone';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaEmail($var, $empresa)
    {
        $campo = 'E-mail';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }

    private function validaNrtipoestrutura($var, $empresa)
    {
        $campo = 'Tipo de Estrutura';
        if(is_null($var)){
            $this->acumulador->addMensagem("fpa_rais_tipo01",array($campo, $empresa), \Geral\Util\Mensagem::ERRO);
        }
    }
}